package RalliJava;

import java.io.PrintStream;
import java.util.Random;

/**
 * @author idamk
 * @version 12.2.2025
 * Vois kirjottaa luokan CRC-kortin vastuut
 *
 */
public class Henkilo {
    
    private int     henkilonTunnusNro       = 0;
    private String  etunimi            = "";
    private String  sukunimi        = "";
    private int     ika             = 0;
    private int     rallienMaara    = 0;
    private int     voitetutRallit  = 0;
    private String  seura           = "";
    private String  kotipaikkakunta = "";
    
    private static int seuraavaNro = 0;
    
    
    /**
     * 
     */
    public void rekisteroi() {
        henkilonTunnusNro = seuraavaNro;
        seuraavaNro++;
    }
    
    
    /**
     * Vastaa randomisti eri henkilöiden tietoja
     */
    public void vastaahlo() {
        
        Random r = new Random();
        int n = r.nextInt(4);
        int s = r.nextInt(4);
        int sr = r.nextInt(5);
        int kp = r.nextInt(7);
        ika = r.nextInt(66);
        rallienMaara = r.nextInt(100);
        voitetutRallit = (rallienMaara - r.nextInt(rallienMaara));
        
        if(n==0) etunimi = "Kalle";
        if(n==1) etunimi = "Teemu";
        if(n==2) etunimi = "Oskari";
        if(n==3) etunimi = "Mikko";
        
        if(s==0) sukunimi = "Rovanperä";
        if(s==1) sukunimi = "Asunmaa";
        if(s==2) sukunimi = "Sokka";
        if(s==3) sukunimi = "Heikkilä";
        
        if(sr==0) seura = "Jyväskylän ralliveikot";
        if(sr==1) seura = "Jämsän autopojat";
        if(sr==2) seura = "Kuopion nopeet";
        if(sr==3) seura = "Rovaniemen nopeet shamaanit";
        if(sr==4) seura = "Keuruun pikamannet";
        
        if(kp==0) kotipaikkakunta = "Jyväskylä";
        if(kp==1) kotipaikkakunta = "Jämsä";
        if(kp==2) kotipaikkakunta = "Kuopio";
        if(kp==3) kotipaikkakunta = "Seinäjoki";
        if(kp==4) kotipaikkakunta = "Hyvinkää";
        if(kp==5) kotipaikkakunta = "Rovaniemi";
        if(kp==6) kotipaikkakunta = "Keuruu";
        
        Henkilo henkilo = new Henkilo(henkilonTunnusNro, etunimi, sukunimi, ika, kotipaikkakunta, seura, rallienMaara, voitetutRallit);
        henkilo.tulosta(System.out);
    }
    
    
    /**
     * @return tunnusnro
     */
    public  int getHenkilonTunnusNro() {
        return henkilonTunnusNro;
    }
    
    /**
     * Alustaa henkilön
     */
    public Henkilo() {
        //ei välttämättä tarttis
    }
    
    /**
     * @param tunnusNro id
     * @param etunimi nimi
     * @param sukunimi sukunimi
     * @param ika ikä
     * @param kotipaikkakunta mistä kotoisin
     * @param seura seura
     * @param rallienMaara rallien määrä
     * @param voitetutRallit voitetut rallit
     */
    public Henkilo(int tunnusNro, String etunimi, String sukunimi, int ika, String kotipaikkakunta, String seura, int rallienMaara, int voitetutRallit) {
    this.etunimi = etunimi;
    this.henkilonTunnusNro = tunnusNro;
    this.sukunimi = sukunimi;
    this.ika = ika;
    this.seura = seura;
    this.kotipaikkakunta = kotipaikkakunta;
    this.rallienMaara = rallienMaara;
    this.voitetutRallit = voitetutRallit;
    }
    
    /**
     * @param tulostettava tietovirta mitä tulostetaan
     */
    public void tulosta(PrintStream tulostettava) {
        tulostettava.println(String.format("%03d", henkilonTunnusNro, 3) + " " + etunimi +  " " + sukunimi + ", ikä: " + ika);
        tulostettava.println("Kotipaikkakunta: " + kotipaikkakunta);
        tulostettava.println("Seura: " + seura);
        tulostettava.println("Osallistunut " + rallienMaara + " ralliin");
        tulostettava.println("Voittanut niistä " + voitetutRallit + ".");
        System.out.println("");
    }
    
    
    /**
     * @return henkilön nimi
     */
    public String getNimi() {
        return this.etunimi + " " + this.sukunimi;
    }
    
    @Override
    public String toString() {
        return "" + 
                getHenkilonTunnusNro()  + "|" +
                sukunimi                + "|" +
                etunimi                 + "|" +
                ika                     + "|" +
                kotipaikkakunta         + "|" +
                seura                   + "|" +
                rallienMaara            + "|" +
                voitetutRallit          + "|";
    }
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Henkilo rovis = new Henkilo();
        Henkilo asunmaa = new Henkilo();
        Henkilo elfyn = new Henkilo();
        rovis.rekisteroi();
        rovis.vastaahlo();
        rovis.tulosta(System.out);
        asunmaa.rekisteroi();
        asunmaa.vastaahlo();
        asunmaa.tulosta(System.out);
        elfyn.rekisteroi();
        elfyn.vastaahlo();
        elfyn.tulosta(System.out);
        
        
    }
}
